(***********************************************************************)
(*                                                                     *)
(*                                CMSV                                 *)
(*                                                                     *)
(*                  Tom Hirschowitz, INRIA Rocquencourt                *)
(*                                                                     *)
(*  Copyright 2003 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  under the terms of the GNU General Public License.                 *)
(*                                                                     *)
(***********************************************************************)


type 'a t = 'a list

let to_list = fun x -> x

let length = List.length
let hd = List.hd
let tl = List.tl
let nth = List.nth
let rev = List.rev
let append = List.append
let rev_append = List.rev_append
let concat = List.concat
let flatten = List.flatten
let iter = List.iter
let map = List.map
let rev_map = List.rev_map
let fold_left = List.fold_left
let fold_right = List.fold_right
let iter2 = List.iter2
let map2 = List.map2
let rev_map2 = List.rev_map2
let fold_left2 = List.fold_left2
let fold_right2 = List.fold_right2
let for_all = List.for_all
let exists = List.exists
let for_all2 = List.for_all2
let exists2 = List.exists2
let mem = List.mem
let memq = List.memq
let find = List.find
let filter = List.filter
let find_all = List.find_all
let partition = List.partition
let assoc = List.assoc
let assq = List.assq
let mem_assoc = List.mem_assoc
let mem_assq = List.mem_assq
let remove_assoc = List.remove_assoc
let remove_assq = List.remove_assq
let split = List.split
let combine = List.combine
let sort = List.sort
let stable_sort = List.stable_sort
let fast_sort = List.fast_sort
let merge = List.merge

(* New functions *)
 
let add = 
  let rec add_rec yet x = function
    | [] -> x :: yet
    | (y :: l) as res when y = x -> rev_append yet res
    | (y :: l) -> add_rec (y :: yet) x l
  in 
  fun x l -> add_rec [] x l

let union l1 l2 = 
  fold_left
    (fun l x -> add x l)
    l2
    l1

let list_union l = 
  List.fold_left
    (fun yet li -> union yet li)
    []
    l

let empty = []
    
let remove x l = 
  let rec remove_rec yet = function
    | [] -> yet
    | y :: l' when x = y -> remove_rec yet l'
    | y :: l' -> remove_rec (y :: yet) l'
  in
  remove_rec [] l
      
let diff l1 l2 = 
  let rec diff_rec yet = function
    | []  -> yet
    | x :: l1' when List.mem x l2 -> diff_rec yet l1'
    | x :: l1' -> diff_rec (x :: yet) l1'
  in
  diff_rec [] l1

let singleton x = [x]
