(***********************************************************************)
(*                                                                     *)
(*                                CMSV                                 *)
(*                                                                     *)
(*                  Tom Hirschowitz, INRIA Rocquencourt                *)
(*                                                                     *)
(*  Copyright 2003 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  under the terms of the GNU General Public License.                 *)
(*                                                                     *)
(***********************************************************************)

open M

let nameX = Name.of_string "X"
let nameY = Name.of_string "Y"
let nameZ = Name.of_string "Z"

let m1 = 
  let rec defX = 
    { label = NamedLocations.Late nameX ;
      body = (begin
	fun env ->
	let y = Obj.magic (NamedLocations.find_local defy env) in
	(Obj.repr
	   (y 0)) 
      end) ;
      size = Unknown ;
      dependencies = [ { target = NamedLocations.Early defy ; degree = Strict } ] }

  and defy = 
    { label = NamedLocations.Early defy ;
      body = (fun env -> 
	let y = Obj.magic (NamedLocations.find_local defy env) in
	(Obj.repr
	   (fun x -> print_string ("Hey gros balourd, le voila ton entier : " ^ (string_of_int x))))) ;
      size = Known 1 ;
      dependencies = [ { target = NamedLocations.Early defy ; degree = Safe } ] }

  and defZ = 
    { label = NamedLocations.Late nameZ ;
      body = (fun env ->
	let y = Obj.magic (NamedLocations.find_local defy env) in
	(Obj.repr y)) ;
      size = Unknown ;
      dependencies = [ { target = NamedLocations.Early defy ; degree = Strict } ;
		       { target = NamedLocations.Late nameX ; degree = Strict } ] }

  in [ defy ; defX ; defZ ]

type m' = { x : int ; z : int -> int }
let m' = (Obj.obj (M.close m1) :  m');;

let _ = m'.z 1


