(***********************************************************************)
(*                                                                     *)
(*                                CMSV                                 *)
(*                                                                     *)
(*                  Tom Hirschowitz, INRIA Rocquencourt                *)
(*                                                                     *)
(*  Copyright 2003 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  under the terms of the GNU General Public License.                 *)
(*                                                                     *)
(***********************************************************************)

#load "name.cmo";;


type definition = { a : int }

module Ident = struct
  type t = Late of Name.t | Early of definition
  let compare x y = match x, y with 
  | Early n1, Early n2 -> if n1 == n2 then 0 else 
    compare n1 n2
  | i1, i2 -> compare i1 i2
end

module A = Map.Make(Ident)

open A;;

let env = A.empty;;

let env = add (Ident.Late (Name.of_string "X")) (Ident.Late (Name.of_string "coucou")) env;;

let def = { a = 0 };;                                                 
let def' = { a = 0 };;

let env = add (Ident.Early def) (Ident.Late (Name.of_string "XX")) env;;
let env = add (Ident.Early def') (Ident.Late (Name.of_string "YY")) env;;

find (Ident.Early def) env;;
- : Ident.t = Ident.Late <abstr>
